
#pragma once

#define CID_ADTF_INTERFACE_SOURCE "demo_interface_sink.demo.adtf.cid"

/**
* A simple demo interface which only provides a function to print a string to the console
*/
class IPrintInterface : public IObject
{
public:
	ADTF_IID(IPrintInterface, "demo_print_interface.demo.adtf.iid");

public:
	virtual tVoid Print(const tChar* strString) = 0;
};

/**
* Demo interface binding source. Provides the cPrinter via a binding server 
* which can be consumed by filter and sink with a binding client.
*/
class InterfaceSink : public cSampleStreamingSink
{
	private:
		object_ptr<IPrintInterface>             m_pPrinter;
        object_ptr<IBindingObject>              m_pBindingClient;
    public:
        ADTF_CLASS_ID_NAME(InterfaceSink, CID_ADTF_INTERFACE_SOURCE, "Demo Interface Sink");

    public:
        InterfaceSink();
		tResult Construct() override;

        tResult Init() override;

        tResult StartStreaming() override;
        
};

