
#include <adtf3.h>
#include "my_interface_binding_filter.h"

///This defines a timer triggered filter. The Triggerfunction cCounterGenerator will be embedded to the Filter
///                                      and called when the timer times out!
ADTF_TIME_TRIGGERED_FILTER_NAME(CID_MY_INTERFACE_BINDING_FILTER,
                                "My Interface Binding Filter",
                                cMyInterfaceBindingFilter,
								cInterfaceBindingTrigger,
                                1000000);

///Implementation of the Plugin 
///The Code behind the Macro create a plugin and the Main Entries to the plugin DLL or shared object
///the cMySignalProviderFilter will be available through the plugins class_factor !
ADTF_PLUGIN("ADTF My Interface Binding Plugin",
	        cMyInterfaceBindingFilter);

tVoid cPrinter::Print(const tChar* strString)
{
    LOG_INFO(strString);
}

tResult cInterfaceBindingTrigger::Configure()
{
	m_pPrinter = make_object_ptr<cPrinter>();
	RETURN_IF_FAILED(create_server<IPrintInterface>(*m_pFilter, "printer_server", m_pPrinter));
	

	RETURN_NOERROR;
}

tResult cInterfaceBindingTrigger::SetFilter(cFilter& oFilter)
{
    m_pFilter = &oFilter;

    RETURN_NOERROR;
}

tResult cInterfaceBindingTrigger::Process(tTimeStamp tmTimeOfTrigger)
{


    RETURN_NOERROR;
}
