
#ifndef _DEMO_TIME_TRIGGER_FUNCTION_FILTER_H_
#define _DEMO_TIME_TRIGGER_FUNCTION_FILTER_H_

//*************************************************************************************************
#define CID_MY_INTERFACE_BINDING_FILTER "my_interface_binding_filter.demo.adtf.cid"

using namespace adtf_util;
using namespace adtf::ucom;
using namespace adtf::streaming;
using namespace adtf::filter;
using namespace adtf::services;

class IPrintInterface : public IObject
{
public:
	ADTF_IID(IPrintInterface, "demo_print_interface.demo.adtf.iid");

public:
	virtual tVoid Print(const tChar* strString) = 0;
    
};

/**
* Implementation of the IPrintInterface interface
*/
class cPrinter : public adtf::ucom::catwo::object<IObject, IPrintInterface>
{
public:
    tVoid Print(const tChar* strString) override;
};

// define a trigger function
class cInterfaceBindingTrigger: public cTriggerFunction
{
private:
	cFilter*							    m_pFilter;
	object_ptr<IPrintInterface>             m_pPrinter;

public:
	/// we need this to get a reference to the filter, so that we can get its name.
    virtual tResult SetFilter(cFilter& oFilter) override;

    /// Called when all properties have been set
    virtual tResult Configure() override;

    /**
     * Overwrites the Process
     * You need to implement the Reading and Writing of Samples within this function
     * MIND: DO Reading until the Readers queues are empty or use the IPinReader::GetLastSample()
     * This FUnction will be called if the Run() of the TriggerFunction was called.
     */
    tResult Process(tTimeStamp tmTimeOfTrigger) override;
};


//*************************************************************************************************
#endif // _DEMO_TIME_TRIGGER_FUNCTION_FILTER_H_
